
/* ====( \usr\src\lookup.h )===== 
*
* box character lookup tables
* used by box_draw.c
* RN May 89
*/


/* 
* lookup for "T" characters
*/
struct _lookupt {
    int v[4];
    unsigned char t_char;
};

/* 
* lookup for double or singlie lines
*/
struct _lookupd {
    int v[4];
    unsigned char d_char;
};

/*
* lookup for cross characters
*/
struct _lookupx {
    int x[4];
    unsigned char x_char;
};


/*
* the following table is used determine the character which has 
* four matching "arms" coordinates
* Example: a single cross would have the coordinates 1,1,1,1  
*          a double cross   "    "    "      "       2,2,2,2
*          a verticle line  "    "    "      "       1,0,1,0
*          a horizontal line"    "    "      "       0,1,0,1
*
*               1
*               |
*           4 --+-- 2 
*               | 
*               3
*/
struct _lookupd lookupd[]={
    0,2,0,2, BHORIZ(3),
    0,1,0,1, BHORIZ(0),
    1,0,1,0, BVERT(0),
    2,0,2,0, BVERT(3),
    0,0,2,2, BURIGHT(3),
    0,0,1,2, BURIGHT(1),
    0,0,1,1, BURIGHT(0),
    0,0,2,1, BURIGHT(2),
    2,0,0,2, BLRIGHT(3),
    1,0,0,1, BLRIGHT(0),
    1,0,0,2, BLRIGHT(1),
    2,0,0,1, BLRIGHT(2),
    0,2,2,0, BULEFT(3),
    0,2,1,0, BULEFT(1),
    0,1,2,0, BULEFT(2),
    0,1,1,0, BULEFT(0),
    2,2,0,0, BLLEFT(3),
    1,2,0,0, BLLEFT(1),
    2,1,0,0, BLLEFT(2),
    1,1,0,0, BLLEFT(0),
};

struct _lookupt lookupt[]={
    1,1,1,0,BLEFTT(0),
    1,2,1,0,BLEFTT(1),
    2,1,2,0,BLEFTT(2),
    2,2,2,0,BLEFTT(3),
    0,1,1,1,BTOPT(0),
    0,1,2,1,BTOPT(2),
    0,2,1,2,BTOPT(1),
    0,2,2,2,BTOPT(3),
    1,0,1,1,BRIGHTT(0),
    1,0,1,2,BRIGHTT(1),
    2,0,2,1,BRIGHTT(2),
    2,0,2,2,BRIGHTT(3),
    1,1,0,1,BBOTTY(0),
    2,1,0,1,BBOTTY(2),
    1,2,0,2,BBOTTY(1),
    2,2,0,2,BBOTTY(3),
};

struct _lookupx lookupx[]={
    1,1,1,1,BCROSST(0),
    1,2,1,2,BCROSST(1),
    2,1,2,1,BCROSST(2),
    2,2,2,2,BCROSST(3),
};

