/* ==( hdr/proc.io )== */

/* ----------------------------------------------- */
/* Pro-C - Copyright (C) 1988, 1989 Vestronix Inc. */
/* Modification to this source is not supported    */
/* by Vestronix Inc.                               */
/*            All Rights Reserved                  */
/* ----------------------------------------------- */

/*
 * Necessary defines for the PRO-C interface to ANY file manager.
*/

#define 	KEY_UNIQUE      0
#define 	KEY_DUPLICATE   1

#define		CHRTYP	0
#define		INTTYP	1
#define		LNGTYP	2
#define		FLTTYP	3
#define		DBLTYP	4
#define		DATTYP	5
#define		LOGTYP	6
#define		MEMTYP	7


/*
* File Access Modes
*/
#define		MODE_MASK	3   /* Don't need any more */

#define 	P_SHARED	 0x10
#define 	P_EXCLUSIVE	 0x20
#define		P_TRANSACT	 0x40

#define		INPUT_FLAG	 0x01
#define		OUTPUT_FLAG	 0x02
#define		UPDATE_FLAG	 0x04
#define		APPEND_FLAG	 0x08

#define 	NOLOCK	    0
#define 	INFLOCK	   -1    /* "infinite" try-forever lock */


/* these will become obsolete... replaced with XXX_FLAG above */
#define     UPDATE_MODE     1
#define     READ_MODE       2
#define     OUTPUT_MODE     3
#define     APPEND_MODE     4

#define     SUCCESS         0
#define     ERASE           0
#define     DISP            1
#define     EXACT           1
#define     PART            0

/*
* Error Codes returned from the I/O interfaces.
*/
#define     IOPERM       -100
#define     IOADD         -90
#define     IO_NO_ADMIN   -80
#define     IONOLOGON     -20
#define     IONOTRANS     -12
#define     IONONEXT      -11
#define     IONOLOCK      -10
#define     IOLOCKED       -9
#define     IOEOF          -8
#define     IOTOF          -7
#define     IODUP          -6
#define     IONOKEY        -5
#define     IOINDEXPOSN    -4
#define     IOBADOPEN      -3
#define     IONOFILE       -2
#define     IOERROR        -1
#define     IOGOOD          0

